itests.sh 3.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103
  1. #!/usr/bin/env bash
  2. # Function to perform cleanup
  3. cleanup() {
  4. echo "Cleaning up..."
  5. # Kill the Rust binary process
  6. echo "Killing the Rust binary with PID $RUST_BIN_PID"
  7. kill $CDK_ITEST_MINT_BIN_PID
  8. # Wait for the Rust binary to terminate
  9. wait $CDK_ITEST_MINT_BIN_PID
  10. echo "Mint binary terminated"
  11. # Kill processes
  12. lncli --lnddir="$cdk_itests/lnd/one" --network=regtest stop
  13. lncli --lnddir="$cdk_itests/lnd/two" --network=regtest --rpcserver=localhost:10010 stop
  14. lightning-cli --regtest --lightning-dir="$cdk_itests/cln/one/" stop
  15. lightning-cli --regtest --lightning-dir="$cdk_itests/cln/two/" stop
  16. bitcoin-cli --datadir="$cdk_itests/bitcoin" -rpcuser=testuser -rpcpassword=testpass -rpcport=18443 stop
  17. # Remove the temporary directory
  18. rm -rf "$cdk_itests"
  19. echo "Temp directory removed: $cdk_itests"
  20. unset cdk_itests
  21. unset cdk_itests_mint_addr
  22. unset cdk_itests_mint_port
  23. }
  24. # Set up trap to call cleanup on script exit
  25. trap cleanup EXIT
  26. # Create a temporary directory
  27. export cdk_itests=$(mktemp -d)
  28. export cdk_itests_mint_addr="127.0.0.1";
  29. export cdk_itests_mint_port_0=8085;
  30. export cdk_itests_mint_port_1=8087;
  31. URL="http://$cdk_itests_mint_addr:$cdk_itests_mint_port_0/v1/info"
  32. # Check if the temporary directory was created successfully
  33. if [[ ! -d "$cdk_itests" ]]; then
  34. echo "Failed to create temp directory"
  35. exit 1
  36. fi
  37. echo "Temp directory created: $cdk_itests"
  38. export MINT_DATABASE="$1";
  39. cargo build -p cdk-integration-tests
  40. cargo build --bin regtest_mint
  41. # cargo run --bin regtest_mint > "$cdk_itests/mint.log" 2>&1 &
  42. cargo run --bin regtest_mint &
  43. echo $cdk_itests
  44. # Capture its PID
  45. CDK_ITEST_MINT_BIN_PID=$!
  46. TIMEOUT=100
  47. START_TIME=$(date +%s)
  48. # Loop until the endpoint returns a 200 OK status or timeout is reached
  49. while true; do
  50. # Get the current time
  51. CURRENT_TIME=$(date +%s)
  52. # Calculate the elapsed time
  53. ELAPSED_TIME=$((CURRENT_TIME - START_TIME))
  54. # Check if the elapsed time exceeds the timeout
  55. if [ $ELAPSED_TIME -ge $TIMEOUT ]; then
  56. echo "Timeout of $TIMEOUT seconds reached. Exiting..."
  57. exit 1
  58. fi
  59. # Make a request to the endpoint and capture the HTTP status code
  60. HTTP_STATUS=$(curl -o /dev/null -s -w "%{http_code}" $URL)
  61. # Check if the HTTP status is 200 OK
  62. if [ "$HTTP_STATUS" -eq 200 ]; then
  63. echo "Received 200 OK from $URL"
  64. break
  65. else
  66. echo "Waiting for 200 OK response, current status: $HTTP_STATUS"
  67. sleep 2 # Wait for 2 seconds before retrying
  68. fi
  69. done
  70. # Run cargo test
  71. cargo test -p cdk-integration-tests --test regtest
  72. # # Run cargo test with the http_subscription feature
  73. cargo test -p cdk-integration-tests --test regtest --features http_subscription
  74. # Switch Mints: Run tests with LND mint
  75. export cdk_itests_mint_port_0=8087;
  76. export cdk_itests_mint_port_1=8085;
  77. cargo test -p cdk-integration-tests --test regtest
  78. # Capture the exit status of cargo test
  79. test_status=$?
  80. # Exit with the status of the tests
  81. exit $test_status